package mofhtml;
#_______________________________________________
#(ء) BBS (MOF HTML LOADER)
$version = 1.9;
#Copyright(C)0xLUV. Y.NAKAMURA.
#no9-0xluv@afis.to

# ѵ 
# ѡۤϼͳ˹Ԥäĺƹޤ󤬡
# ޤ
# եƬCopyrightɽڤ $copyright 
# $version Ƥѹʤǲ
# ޤǤλѡۤϲѤȤ
# ǹԤäƲ
# ܥץȤ̵̵ݾڤǤ
# Ѥ˴ؤ뤹٤ƤˤƻѼԤǤΤȤǹ
# ΤȤԤϤǤΰڤ餤ޤ
#_______________________________________________

if(! defined($main::version)){ require 'mofbbs.pl'; }

#___________________________________________________________





%item;

%page = (PAGE => 0, PREV => 0, NEXT => 0, SEQUENCE => '');

%href = (
	PREV => 0,		NEXT => 0,
	PREVONE => 0,	NEXTONE => 0,
);





#___________________________________________________________

require 'mofmac.pl';
my(%MAC) = (
	DATE => 'date',
	MAIL => 'mail',
	WRAP => 'wrap',
	TRIM => 'trim',
	ICON => 'icon',
	TABLE => 'create_table',
);


my(%tags);



#___________________________________________________________
sub parse_section {
	local($section_name, $class, $val) = @_;
	local($prefix);
	if($class =~ s/^\_//){ $prefix = "\_"; }
	if($class =~ /^[A-Z][A-Z_]+$/){
		$val =~ s/^<\_([A-Z_]+)::([A-Z_]+)>$/$tags{"$1\_$2"}/g;
		$tags{"$section_name\_$class"} = $val;
	}
	return ($prefix.$class);
}


sub parse_element {
	local($class, %element) = @_;
	local($data) = $tags{$class};
	(! %element) && return " ";

	local($key, $val, $tag, $prefix);
	while( ($key, $val) = each(%element) ){
		if( exists($tags{"$class\_$key"}) ){
			$tag = $tags{"$class\_$key"};
			$tag =~ s/[\r\n]//g;
			if($tag =~ /^\{(.+)\} \: \{(.+)\}$/s){ $tag = ( ($val ne "")&&($val ne " ") ) ? $1 : $2; }
			if($tag =~ /^([A-Z]+)\((.+)\)$/m){ $tag = ( exists($MAC{$1}) ) ? ( eval('&mofmac::'.$MAC{$1}.'($val,$2)') ) : $val; }
			$tag =~ s/<$key>/$val/g;
		}else{
			$tag = $val;
		}
		if($key =~ /^(\QHREF_\E[A-Z]+)/){
			$data =~ s/\Q<!-- <\E$1\Q> -->\E/$tag/g;
		}else{
			$data =~ s/\Q<!-- <_\E$key\Q> -->\E/$tag/g;
		}
	}

	return $data;
}


sub analyze {
	local($style) = $_[0];

	&mof::load_mof(local(*tag), "$mof::directory{HTML}\/$mof::file_style{$style}") || return 0;
	( ($copyright =~ /\w+/)&&($tag =~ s/\Q<!-- <&COPYRIGHT> -->\E/$copyright/g) ) || return 0;
	$tag =~ s/\Q<!-- <SCRIPT_\E([A-Z_]+)\Q> -->\E/$mof::script{$1}/g;
	$tag =~ s/\Q<!-- <COMMAND_\E([A-Z]+)\Q> -->\E/$main::cmd{$1}/g;
	$tag =~ s/\Q<!-- <SORT_BY_\E([A-Z]+)\Q> -->\E/$main::cmd{SORT}$1/g;

	local(@section_block) = split(/^\<\!\-\- \<\<\/\>\> \-\-\>$/m, $tag);
	foreach $_ (@section_block){
		if($_ =~ s/^\Q<!-- <__\E([A-Z][A-Z_]+)\Q> -->\E$//m){ $tags{$1} .= $'; }
	}

	local($body) = ($tags{GRAPH} =~ /^\<([A-Z_]+)\>/) ? $1 : "BODY";
	$tags{$body} =~ s/\Q<!-- <&\E([A-Z][0-9A-Z_]+)\Q> -->\E/eval( ('$'."\L$1\E") )/ge;
	$tags{$body} =~ s/\Q<!-- <\E(M\_)?\QMETA_CHARSET> -->\E/&mofmac::meta_charset($1)/e;

	local(@check, $tailstr, $section);
	while($tags{GRAPH} =~ /([A-Z_]+)/g) {
		$section = $1;
		@check = split(/\Q\\ -->\E/, $tags{$section});
		$tailstr = pop(@check);
		$tags{$section} = "";
		foreach $_ (@check){
			($_ =~ s/\Q<!-- <\E(\_?[A-Z][A-Z_]+)\Q>=\\\E(.+)/sprintf("\<\!-- \<%s\> --\>", (&parse_section($section, $1, $2)))/se) || ($_ .= "\\\\ -->");
			$tags{$section} .= $_;
		}
		$tags{$section} =~ s/\Q\\ -->\E$//;
		$tags{$section} .= $tailstr;
	}
	return 1;
}


sub set_page_sequence {
	local($size, $max, $append) = @_;
	($max > 1) || return " ";
	local($cnt);
	for($cnt=1; $cnt<$size; $cnt+=$max){
		$page{SEQUENCE} .= " <a href=\"$href{SELF}$cnt\-$append\">$cnt<\/a> ";
	}
	return $cnt;
}


sub publish {

	$HREF_SELF = $href{SELF};
	delete($href{SELF});
	foreach $_ ( keys(%href) ){
		$href{"HREF\_$_"} = ($href{$_} =~ /\S+/) ? $HREF_SELF.$href{$_} : " ";
		delete($href{$_});
	}
	$HREF_SELF =~ s/\?$//;
	foreach $_ ( keys(%tags) ){
		$tags{$_} =~ s/\Q<!-- <PAGE_\E(CURRENT|PREV|NEXT|TOTAL|SEQUENCE)\Q> -->\E/$page{$1}/g;
		$tags{$_} =~ s/\Q<!-- <HREF_SELF> -->\E/$HREF_SELF/g;
	}

	local(@graph);
	while($tags{GRAPH} =~ /<([A-Z_]+)>/g){
		push(@graph, $1);
		$item{$1} = " ";
	}
	($#graph < 0) && return "MISS !";
	$tags{ $graph[0] } = &parse_element($graph[0], %href);


	if($item{ELEMENTS} =~ /<\d+>/){
		local($itemlist) = $item{ITEMLIST};
		@itemlist = eval( ('@mof::'.$itemlist) );
		($#itemlist < 0) && goto RET;

		local(%element);
		local(
			$data, $parent, $child,
			$level, $prev_level,
		);

		$level = $#graph;
		foreach $data ( split(/\n/, $item{ELEMENTS}) ){

			($data =~ /^[^\r\n]+/) || next;

			if($data =~ /^<(\d+)>$/){
				$prev_level = $level;
				$level = $1 + 0;
				next;
			}
			if( ($level == 0)&&($#graph <= 1) ){
				$item{ $graph[-1] } = $child;
				last;
			}

			%element = ();
			%element = &mof::unpack_item($data, @itemlist);
			if($level < $prev_level){
				$data .= ($itemlist[0].$child);
				$element{ $graph[($level +1)] } = $child;
				$item{ $graph[$level] } .= &parse_element($graph[$level], %element);
				$child = "";
			}elsif( ($data =~ /\d{10,}/)&&($level > 0) ){
				$child .= &parse_element($graph[$level], %element);
			}
		}

	}

RET :
	delete($item{ELEMENTS});
	print "Content-Type: text/html\n\n";
	print (&parse_element($graph[0], %item));
	return 1;
}


1;
