#_______________________________________________
#(EցE) BBS (COMMON LIBRATY for WRITER)
# $version = 1.9;
#Copyright(C)0xLUV. Y.NAKAMURA.
#no9-0xluv@afis.to

# gp F
# ρEĔzz͎RɍsĒč\܂񂪁A
# 쌠͕܂B
# t@C`Copyright\y $copyright 
# $version ̓e͕ύXȂŉB
# ܂Aϔł̎gpEzz͉ςƂ𖾋L
# ōsĉB
# {XNvg͖Ŗۏ؂łB
# gpɊւ邷ׂĂɂĎgp҂̐ӔĈƂōs
# ̂ƂA҂͂̐ӔC̈؂𕉂܂B
#_______________________________________________

( defined($main::copyright) ) || require 'mofbbs.pl';

#___________________________________________________________





package mof;
#___________________________________________________________
%rule_list = (
	TITLE => "s+",
	NAME => "s+",
	MSG => "m+",
);
while( ($key, $val) = each(%record_rules) ){ $rule_list{$key} = $val; }
$rule_list{DATE} = "s+";
# undef($key, $val, %record_rules);
#___________________________________________________________





#___________________________________________________________
sub write_mof {
	local($mode, $path, $data) = @_;
	$path = "$directory{BASE}\/$path$ex";
	open(REC, "$mode$path") || return 0;
	print REC $data;
	close(REC);
	chmod((0777), $path);
	return 1;
}


sub write_image {
	local($path, $image_data) = @_;
	$path = "$directory{BASE}\/$directory{ICON}\/$directory{USERS}\/$path";
	open(WRITE_IMG, "+>$path") || return 0;
	binmode WRITE_IMG;
	print WRITE_IMG $image_data;
	close(WRITE_IMG);
	chmod((0777), $path);
	return 1;
}


sub tag_check {
	local($str) = $_[0];
	$str =~ s/\&/\&amp\;/g;
	$str =~ s/\"/\&quot\;/g;
	$str =~ s/</\&lt\;/g;
	$str =~ s/>/\&gt\;/g;
	return $str;
}


sub multi_line_check {
	local($str) = $_[0];
	$str =~ s/\t/ \&nbsp\; \&nbsp\; \&nbsp\;/g;
	$str =~ s/\r\n|\r/\n/g;
	$str =~ s/(http|ftp|https|rstp|mms)\:\/\/[^ \n\t]+[\=\?\!-\;\@-\~]/<a href=\"$&\" target=\"\_blank\">$&<\/a>/ig;
	$str =~ s/\n/<br>/g;
	return $str;
}


sub unpack_url {
	local($str, $type) = @_;
	local($splitter_1, $splitter_2) = ($type ne "draw") ? ('\&', '\=') : ('\%09', '\%3d');
	(defined($jcode::rcsid)) || require 'jcode.pl';
	foreach $_ ( split(/$splitter_1/, $str) ){
		if($_ =~ /^([A-Z_]+)$splitter_2(.*)$/mi){
			($key, $val) = ($1, $2);
			$val =~ s/\+/ /g;
			$val =~ s/\%([a-f0-9]{2})/pack("C", hex($1))/ige;
			$record{$key} = &jcode::to($char_code, $val);
		}
	}
	return %record;
}


sub record_check {
	local($record) = @_;
	if(! exists($record->{DATE}) ){ $record->{DATE} = &pack_item('itemlist_date', (&get_date)); }
	if( exists($rule_list{HOST}) ){ $record->{HOST} = "$ENV{REMOTE_HOST}\/$ENV{REMOTE_ADDR}\/$ENV{HTTP_X_FORWARDED_FOR}"; }
	if( ( exists($record->{PARENT}) )&&(-f "$directory{BASE}\/$directory{LOG}\/$record->{PARENT}$ex") ){
		$rule_list{TITLE} = "s";
		$record->{TITLE} = " ";
	}else{
		delete($record->{PARENT});
	}
	foreach $_ ( keys(%rule_list) ){
		if(! exists($record->{$_}) ){ return 0; }
		if( ($rule_list{$_} =~ /\+/)&&($record->{$_} !~ /.+/m) ){
			return 0;
		}elsif($record->{$_} =~ /.+/){
			$record->{$_} = &tag_check($record->{$_});
			if($rule_list{$_} =~ /m/){
				$record->{$_} = &multi_line_check($record->{$_});
			}else{
				$record->{$_} =~ s/[\r\n\t]|( {2,})//g;
			}
		}else{
			$record->{$_} = " ";
		}
	}
	return 1;
}


sub record {
	local(%record) = @_;
	if( exists($record{ismail}) ){
		delete($record{ismail});
	}elsif(
		((-M "$directory{BASE}\/$file_system{LOGLIST}$ex") < (0.0001))
		||
		(! &record_check(\%record))
	){ return 0; }

	( defined($mofmac::version) ) || require 'mofmac.pl';
	local(%log_inex);
	$log_index{SIZE} = 0;
	local($new_id) = &mofmac::date($record{DATE}, "<YEAR><MONTH02><DAY02><HOUR02><MIN02><SEC02>");
	$record{ID} = $new_id;
	local($mode) = '+>';
	local($parent) = $record{PARENT};

	&load_mof(local(*loglist), $file_system{LOGLIST});
	if($loglist =~ /^$new_id[^\r\n]+$/m){ return 0; }
	if( (-f "$directory{BASE}\/$directory{LOG}\/$parent$ex")&&($loglist =~ s/([\r\n]?)($parent[^\r\n]+)[\r\n]/$1/) ){
		%log_index = &unpack_item($2, @itemlist_recordindex);
		if($log_index{SIZE} == $record_max){
			$record{TITLE} = $log_index{TITLE}."\+";
			%log_index = %record;
		}else{
			$mode = '>>';
			$record{ID} = $parent;
			$record{TITLE} = " ";
		}
	}else{
		%log_index = %record;
	}
	$log_index{SIZE}++;
	$log_index = &pack_item('itemlist_recordindex', %log_index);
	$loglist = "$log_index\n$loglist";

	&write_mof('+>', $file_system{LOGLIST}, $loglist) || return 0;
	$record{MSG} = &mofmac::trim($record{MSG}, $message_max);
	&write_mof($mode, "$directory{LOG}\/$record{ID}", (sprintf("%s\n", &pack_item('itemlist_record', %record))) ) || return 0;

	return ($record{ID}, $log_index{SIZE});
}


1;
