package mofmac;
#_______________________________________________
#(ء) BBS (MOF MACRO)
$version = 1.9;
#Copyright(C)0xLUV. Y.NAKAMURA.
#no9-0xluv@afis.to

# ѵ 
# ѡۤϼͳ˹Ԥäĺƹޤ󤬡
# ޤ
# եƬCopyrightɽڤ $copyright 
# $version Ƥѹʤǲ
# ޤǤλѡۤϲѤȤ
# ǹԤäƲ
# ܥץȤ̵̵ݾڤǤ
# Ѥ˴ؤ뤹٤ƤˤƻѼԤǤΤȤǹ
# ΤȤԤϤǤΰڤ餤ޤ
#_______________________________________________





#___________________________________________________________
sub meta_charset {
	local($is_mobile) = $_[0];
	local(%char_set) = (euc => "euc-jp", sjis => "shift_jis", jis => "iso-2022-jp");
	local($char_code) = ($is_mobile) ? $char_set{$mof::m_char_code} : $char_set{$mof::char_code};
	return ("<meta http\-equiv\=\"content\-type\" content=\"text\/html\; charset\=$char_code\">");
}

sub date {
	local($date_str, $date_fmt) = @_;
	if(! defined($main::copyright)){ require 'mofbbs.pl'; }
	local(%date) = &mof::unpack_item($date_str, @mof::itemlist_date);
	$date_fmt =~ s/\<([A-Z]+)(\d*)\>/sprintf("%$2d", $date{$1})/ge;
	return $date_fmt;
}


sub mail {
	local($mail_str, $mail_fmt) = @_;
	@mail_str = split(/\@/, $mail_str, 2);
	$mail_fmt =~ s/\<ACOUNT\>/$mail_str[0]/g;
	$mail_fmt =~ s/\<DOMAIN\>/$mail_str[1]/g;
	return $mail_fmt;
}


sub icon {
	local($icon, $option) = @_;
	if(! defined($main::copyright)){ require 'mofbbs.pl'; }
	local($full_path) = "$mof::directory{BASE}\/$mof::directory{ICON}";
	if(! (-f "$full_path\/$icon")){
		$icon = $mof::ico_default;
	}else{
		local(%imginfo, $imglist, $img);
		&mof::load_mof(*imglist, $mof::file_system{IMGLIST});
		foreach $img ( split(/\n/, $imglist) ){
			if($img =~ /$icon/){
				%imginfo = &mof::unpack_item($img, @mof::itemlist_imageindex);
				$option .= " alt=\" $imginfo{IMAGENAME} \"";
				last;
			}
		}
	}
	local($tag) = "<img src=\"$mof::directory{ICON}\/$icon\" $option>";
	if( ($icon =~ s/$mof::directory{USERS}\///)&&(-f "$full_path\/$mof::directory{USERS}\/$mof::users_thumb_prefix$icon") ){
		$tag =~ s/$icon/$mof::users_thumb_prefix$icon/;
		$tag =
		sprintf(
			"<a href=\"%s\/%s\/%s\" target=\"_blank\">%s<font style=\"font-size:7pt; background-color:#000000; color:#ffffff; text-decoration:none;\"><b>\&gt\;\&gt\;<\/b><\/font><\/a>",
			$mof::directory{ICON},
			$mof::directory{USERS},
			$icon,
			$tag
		);
	}

	return $tag;
}


sub wrap {
	local($str, $size) = @_;

	if(length($str) > $size){
		local($str_block, $tag_block, $newstr);
		if($str =~ /\<[^\>]+\>|\&nbsp\;|\&amp\;|\&quot\;|\&gt\;|\&lt\;/i){
			local($last_wrap);
			while($str =~ /([^\<]*)(\<[^\>]+\>|\&nbsp\;|\&amp\;|\&quot\;|\&gt\;|\&lt\;)/ig){
				($str_block, $tag_block) = ($1, $2);
				$str_block =~ s/([\=\?\!-\;\@-\~]{$size})/$1\<br\>/g;
				$newstr .= ($str_block.$tag_block);
				$last_wrap = pos($str);
			}
			if( ($str =~ /^.{$last_wrap}/)&&($last_wrap < length($str)) ){ $newstr .= $'; }
			$str = $newstr;
		}else{
			$str =~ s/([\=\?\!-\;\@-\~]{$size})/$1\<br\>/g;
		}
	}

	return $str;
}


sub trim {
	local($str, $size) = @_;
	local($strmax) = length($str);
	if($strmax > $size){
		$strmax = $size -1;
		local($substr) = substr($str, 0, $strmax);
		$substr =~ s/(.)/sprintf("%02x ", ord($1))/ge;
		local($tailpos) = 0;
		while($substr =~ /([^2-7][a-f\d] ){2}/g){ $tailpos = pos($substr); }
		local($tail);
		if($tailpos > ($strmax -9)){
			$tail = substr($substr, $tailpos, $size);
			$tail =~ s/([^2-7][a-f\d] )//g;
			$substr = substr($substr, 0, $tailpos);
			$substr .= $tail;
		}
		$substr =~ s/([a-f\d][a-f\d]) ?/(pack("C", (hex($1))))/ge;
		$str = $substr." ...";
	}
	return $str;
}


sub create_table {
	local($data, $cell_size) = @_;
	$data =~ s/^[\r\n]+//sg;
	$data =~ s/[\r\n]+$//sg;
	$data =~ s/([^\r\n])[\r\n]+/$1\n/g;
	@data = split(/\n/, $data);
	$cell_size = ($cell_size =~ /(\d+)/) ? $1 : 5;
	local(@table);
	while($#data >= 0){
		push(@table, "<tr>");
		push(@table, splice(@data, 0, $cell_size));
		push(@table, "<\/tr>");
	}
	return join("", @table);
}


1;
